import sys
import argparse
from deep_translator import GoogleTranslator
import locale

class PrintTranslator:
    @staticmethod
    def traducir_print(*args, idioma_destino=None):
        # Detecta el idioma local si no se pasa uno específico
        idioma_local = locale.getdefaultlocale()[0].split('_')[0] if idioma_destino is None else idioma_destino

        # Traducir el mensaje a través de Google Translator
        texto = ' '.join(map(str, args))
        texto_traducido = GoogleTranslator(source='auto', target=idioma_local).translate(texto)

        # Imprimir el texto traducido
        print(texto_traducido)

    @staticmethod
    def traducir(*args, destino=None):
        return PrintTranslator.traducir_print(*args, idioma_destino=destino)

# Redefinir print_traducido para que utilice la traducción
def print_traducido(*args, **kwargs):
    destino = kwargs.get("destino", None)
    PrintTranslator.traducir(*args, destino=destino)

# Hacer que 'print' sea un alias para 'print_traducido'
print = print_traducido

# Si quieres que el script pueda ser ejecutado desde consola, agrega esto
if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Traductor de prints en consola.")
    parser.add_argument('texto', type=str, help="Texto a traducir")
    parser.add_argument('--destino', type=str, help="Idioma destino (ej. 'es', 'en', etc.)")

    args = parser.parse_args()

    # Traducir el texto desde la consola
    PrintTranslator.traducir(args.texto, destino=args.destino)
